% demo01 ---- using FastICA to separating four mixed artificial signals
% ˵
%    ʾļҪʾÿٹ̶㷨ĸϵ˹źš
%    ʹ߿ģ±űļ趨пٹ̶ICA㷨ʾ
% 
% õĺļб
%        ffpICA.m   ------  ٹ̶ICA㷨Ҫ㷨
%        gensig.m   ------  ˹ϳźţ4
%     removmean.m   ------  ȥֵʹźžֵΪ0
%        remstd.m   ------  ȥʹźŷΪ1
%     whitenSig.m   ------  źŽа׻Ԥ
%
% ߣ֣Zhang Zhi-Lin
%       zhangzl@vip.163.com
%       http://teacher.uestc.edu.cn/teacher/teacher.jsp?TID=zzl80320
% 汾1.0
% ڣ20031031


close all;clear;clc;
%====================== ԭʼź,λֵ =======================
N = 5000;
sig=gensig(N,'off');  
% sig(1,:)=randn(1,5000); 
% sig(2,:)=randn(1,5000);

% ź
figure;  
subplot(4,1,4);
    plot(sig(4,[N-499:N])); ylabel('s4');
    axis([-inf,inf,-5,5]);
subplot(4,1,3); 
    plot(sig(3,[N-499:N])); ylabel('s3');
    axis([-inf,inf,-5,5]);
subplot(4,1,2); 
    plot(sig(2,[N-499:N])); ylabel('s2');
    axis([-inf,inf,-5,5]);
subplot(4,1,1); 
    plot(sig(1,[N-499:N])); ylabel('s1'); title('\bf source signals');
    axis([-inf,inf,-5,5]);
   
%============================ õź ==================================
A=rand(size(sig,1));           % ĻϾ
MixedSig=A*sig;                
% ź
figure;  
subplot(4,1,4); 
    plot(MixedSig(4,[N-499:N])); ylabel('x4');
subplot(4,1,3); 
    plot(MixedSig(3,[N-499:N])); ylabel('x3');
subplot(4,1,2);
    plot(MixedSig(2,[N-499:N])); ylabel('x2');
subplot(4,1,1); 
    plot(MixedSig(1,[N-499:N])); ylabel('x1'); title('\bf mixed signals');
    
%=========================== źŽа׻ ==================================
[WhitenedSig,WhitenMatrix]=whiten(MixedSig);     % źŽа׻
V=WhitenMatrix;
% ׻ź
figure;    
subplot(4,1,4); 
    plot(WhitenedSig(4,[N-499:N])); ylabel('z4');
subplot(4,1,3); 
    plot(WhitenedSig(3,[N-499:N])); ylabel('z3');
subplot(4,1,2); 
    plot(WhitenedSig(2,[N-499:N])); ylabel('z2');
subplot(4,1,1); 
    plot(WhitenedSig(1,[N-499:N])); ylabel('z1'); title('\bf whitened signals');

    
%========================= ù̶ICA ========================
tic
[Sig,WeightMatrix]=FastICA(WhitenedSig,'method','defl','nonlinfunc','tanH');
toc
W=WeightMatrix;

%========================== ָźΪ0ֵλ ===========================

% ָź
figure;  
subplot(4,1,4);
    plot(Sig(4,[N-499:N])); ylabel('y4');
    axis([-inf,inf,-5,5]);
subplot(4,1,3); 
    plot(Sig(3,[N-499:N])); ylabel('y3');
    axis([-inf,inf,-5,5]);
subplot(4,1,2); 
    plot(Sig(2,[N-499:N])); ylabel('y2');
    axis([-inf,inf,-5,5]);
subplot(4,1,1); 
    plot(Sig(1,[N-499:N])); ylabel('y1');
    title('\bf separated sources');
    axis([-inf,inf,-5,5]);

%========================== ʾ ===========================
fprintf('==============================================\n');
fprintf('            Results of calculation            \n');
fprintf('==============================================\n');
disp(W'*V*A);
fprintf('Matrix of Separation Performance ...\n');
fprintf('Performance index: %g\n',CTPI(W'*V*A,'norm'));
