% demo02.m ---- using FastICA to separating two mixed audio waves
% ˵
%    ʾͨFastICA㷨ϵʵź
%    £źšȻͨһĻϾ󣬽
%    źŻͨFastICA㷨Ƿ
% First done: 4,Oct.,2003
% Last done : 10,Oct.,2003

%--------------------------------------------------
% źţʾμһƵ
clear;clc;close all;
[s1,FS,NBITS]=wavread('source1.wav',160000);    % Դź1
s2=wavread('source2.wav',160000);               % Դź2

s1=s1/std(s1);             % ʹs1Ϊ1
s1=s1-mean(s1);            % ʹs1ֵΪ0
s2=s2/std(s2);             % ʹs2Ϊ1
s2=s2-mean(s2);            % ʹs2ֵΪ0


figure;subplot(2,1,2);plot(s2);subplot(2,1,1);plot(s1);title('\bfԭʼ');

f=[0:160000-1]/160000;
y1=fft(s1');y2=fft(s2');
figure;subplot(2,1,2);plot(f,abs(y2));subplot(2,1,1);plot(f,abs(y1));title('\bfԭʼһƵ');

%-------------------------------------------------
% źϣʾ䲨κ͹һƵףɻļ
A=rand(2);               % Ͼ
X=A*[s1';s2'];           % źţXÿдһռĻź
% X=remstd(X);             % ʹΪ1
% X=removmean(X);          % ʹֵΪ0

figure;subplot(2,1,2);plot(X(1,:));subplot(2,1,1);plot(X(2,:));title('\bf');
z1=fft(X(1,:)');z2=fft(X(2,:)');
figure;subplot(2,1,2);plot(f,abs(z2));subplot(2,1,1);plot(f,abs(z1));title('\bfһƵ');

wavwrite(X(1,:)',FS,NBITS,'demo02mix1.wav');
wavwrite(X(2,:)',FS,NBITS,'demo02mix2.wav');

%------------------------------------------------------
% ԻԤ׻
WhitenedSig = whiten(X);
%------------------------------------------------------
% FastICA㣬ʾɷļ

% ٹ̶ICA㷨(Fast Fixed-Point ICA algorithm)
[Sig,WeightMatrix]=FastICA(WhitenedSig,'method','symm','nonlinfunc','tanh');

% ָźΪ0ֵλ
Sig=remstd(Sig);             % ʹΪ1
Sig=Sig-(mean(Sig'))'*ones(1,160000);           % ʹֵΪ0


wavwrite(Sig(1,:)',FS,NBITS,'demo02sd1.wav');
wavwrite(Sig(2,:)',FS,NBITS,'demo02sd2.wav');

figure;subplot(2,1,2);plot(Sig(2,:));subplot(2,1,1);plot(Sig(1,:));title('\bfָ');

sp1=fft(s1');sp2=fft(s2');
figure;subplot(2,1,2);plot(f,abs(sp2));subplot(2,1,1);plot(f,abs(sp1));title('\bfԭʼһƵ');
