function sig=gensig(N,para)
% GENSIG  ---- generate four artificial signals with zero mean and unit variance.
% 
%     sig=gensig(N,para)
%   sigΪһÿдһźŵвֵУĸźţ
%   ÿǶĸźŵһι۲⡣
%   ĸźźţ߲źţǲźţ
%
% 
%        N   ָźŵĳȣĬֵΪ500
%             para   ֵΪ'on' ʾɵź;'off'ʾɵźţĬֵΪ'on'
% øʽ
%     sig=gensig(N,'on'); sig=gensig(N,'off');
%     sig=gensig(N);
%     sig=gensig;                  
%
% ߣ֣Zhang Zhi-Lin
%       http://teacher.uestc.edu.cn/teacher/teacher.jsp?TID=zzl80320
% 汾1.1
% ڣ20031030


%====================================================================
% Ĭϲ
if(nargin<2) para='on'; end;   % paraȡĬֵʾɵźͼ
if(nargin<1) N=500;  end;   % NȡĬֵ500

%====================================================================
% 
switch lower(para)
    case 'on'
        show=1;
    case 'off'
        show=0;
    otherwise
        error(sprintf('Illegal value [ %s ] for parameter: ''para''\n', para));
end

%====================================================================
% ź
v=[0:N-1];
sig(1,:)=sin(v/2);   % ź
sig(2,:)=((rem(v,23)-11)/9).^5; % ߲
sig(3,:)=((rem(v,27)-13)/9);    % ǲ
sig(4,:)=((rand(1,N)<.5)*2-1).*log(rand(1,N)); % 

if(show)    % ͼ
    figure;
    subplot(4,1,4); 
        plot(sig(4,[N-499:N])); ylabel('');axis([-inf,inf,-5,5]);
    subplot(4,1,3); 
        plot(sig(3,[N-499:N])); ylabel('ǲ');axis([-inf,inf,-5,5]);
    subplot(4,1,2); 
        plot(sig(2,[N-499:N])); ylabel('߲');axis([-inf,inf,-5,5]);
    subplot(4,1,1); 
        plot(sig(1,[N-499:N])); ylabel('Ҳ'); title('\bf\fontsize{14}ԭʼź');
        axis([-inf,inf,-5,5]);
end

sig = standarize(sig);       % ׼λֵ



